/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 11 (Equation 1.6)
**
*/

new;
library rpb,pgraph;

cls;

let mu =    0.05 0.06 0.08 0.06;
let sigma = 0.15 0.20 0.25 0.30;
n = rows(sigma);
let rho =   1.00 
            0.10   1.00
            0.40   0.70   1.00
            0.50   0.40   0.80 1.00;
rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';
A = ones(1,n); B = 1;

Bounds = (-1e100~1e100) .* ones(n,1);
phi = 0.001|0.10|1;
gamma_ = 1/phi;
{x0,mu0,sigma0,gamma0,retcode} = Compute_MVO_Portfolio(mu,cov,A,B,0,0,Bounds,gamma_,0);  

phi0 = 1/gamma0;

I = invpd(cov);
e = ones(n,1);
x1 = (I*e)/(e'I*e) + (1/phi') .* ( -(e'*I*mu)*I*e + (e'*I*e)*I*mu )/(e'I*e);
print ftosa(x0,"%lf",3,2);
print "------------------------------------------------------------------------------------";

print ftosa(x1,"%lf",3,2);
print "------------------------------------------------------------------------------------";

print ftosa(x1-x0,"%lf",3,5);
print "------------------------------------------------------------------------------------";
