/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Pages 17 & 18 (Tables 1.5 & 1.6)
**
*/

new;
library rpb,pgraph;

cls;

let mu =    0.05 0.06 0.08 0.06;
let sigma = 0.15 0.20 0.25 0.30;
n = rows(Sigma);
let rho =   1.00 
            0.10   1.00
            0.40   0.70   1.00
            0.50   0.40   0.80 1.00;
rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';
A = ones(1,n); B = 1;

r = 0.015;

/*
**> Tangency portfolio
**
*/

y = rndu(n,1);
y = y / sumc(y);
y = ones(n,1)/n;

gamma_ = seqa(0,1/4000,10000);

Bounds = (-3~3) .* ones(n,1);
{x0,mu0,sigma0,gamma0,retcode} = Compute_MVO_Portfolio(mu,cov,A,B,0,0,Bounds,gamma_,0);  
SR = (mu0-r)./sigma0;
indx = maxindc(SR);
x = x0[.,indx]; mu_x = mu0[indx]; sigma_x = sigma0[indx]; 

print ftos(100*mu_x,"mu(x) = %lf",3,2);
print ftosa(100*(x~y),"%lf",3,2);
mu_y = y'mu;

e = eye(4);
_beta = (e'*cov*x)/(x'*cov*x);
_beta = _beta | (y'*cov*x)/(x'*cov*x);
mu__beta = _beta .* (mu_x - r);
print ftosa(seqa(1,1,5)~100*((mu|mu_y)-r)~_beta~100*mu__beta,"%lf",3,2);
print "-------------------------------------------------------------------------";

Bounds = (0~1) .* ones(n,1);
{x0,mu0,sigma0,gamma0,retcode} = Compute_MVO_Portfolio(mu,cov,A,B,0,0,Bounds,gamma_,0);  
SR = (mu0-r)./sigma0;
indx = maxindc(SR);
x = x0[.,indx]; mu_x = mu0[indx]; sigma_x = sigma0[indx]; 

print ftos(100*mu_x,"mu(x) = %lf",3,2);
print ftosa(100*(x~y),"%lf",3,2);
mu_y = y'mu;

e = eye(4);
_beta = (e'*cov*x)/(x'*cov*x);
_beta = _beta | (y'*cov*x)/(x'*cov*x);
mu__beta = _beta .* (mu_x - r);
print ftosa(seqa(1,1,5)~100*((mu|mu_y)-r)~_beta~100*mu__beta,"%lf",3,2);


