/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 51 (Correlation matrix 1.24)
**
*/

new;
library rpb,pgraph;

cls;

PathName = "data\\";
datFileName = PathName $+ "equity-indices-weekly.dat";
Data = loadd(datFileName);
vnames = lower("" $+ getname(datFileName));

BeginDate = 20050101;
LastDate = 20111231;
Data = selif(Data,(Data[.,1] .>= BeginDate) .and (Data[.,1] .<= LastDate));

let string selected_names = "spx" "sxxe" "ukx" "tpx" "bovespa" "rts" "nifty" "hsi";
let Factors               = 1     1      1     1     2         2     2       2;

indx = indsav(selected_names,vnames);
Dates = Data[.,1];
x = Data[.,indx];
R = x ./ lag1(x) - 1.0;
R = packr(R);

{Sigma,alpha,Sigma1,Sigma2} = Shrinkage_LW_CC(R);

stddev = sqrt(diag(Sigma1));
C1 = Sigma1 ./ stddev ./ stddev';

stddev = sqrt(diag(Sigma2));
C2 = Sigma2 ./ stddev ./ stddev';

stddev = sqrt(diag(Sigma));
C = Sigma ./ stddev ./ stddev';

print ftosa(100*C1,"%lf",1,2);
print ftosa(100*C2,"%lf",1,2);

print ftosa(miss(lowmat(C),0),"%lf",3,2);

print ftosa(100*alpha,"alpha = %lf",3,1);

