/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 55 (Tables 1.10 & 1.11)
**
*/

new;
library rpb,pgraph;

cls;

__output = 0;

n = 3;
let mu    = 0.08 0.08 0.05; 
let sigma = 0.20 0.21 0.10;
rho = 0.80;
rho = diagrv(rho*ones(n,n),1.0);
cov = rho .* sigma .* sigma';
call invpd(cov);

{va1,ve1,PCAmatrix} = regPCA(cov,0);
c1 = cumsumc(va1/sumc(va1));

result = ve1|va1'|c1';
print ftosa(100*result,"%lf",3,2);

{va2,ve2,PCAmatrix} = regPCA(invpd(cov),0);
c2 = cumsumc(va2/sumc(va2));

result = ve2|va2'/100|c2';
print ftosa(100*result,"%lf",3,2);
  