/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Pages 88-90 (Example 8)
**
*/

new;
library rpb,pgraph;

cls;

Let L[2,20] =   14  3   -4  5   6   8   12  25  23  -9  -50 -17  18  -9   -6    -2  0  17 19 1
                10  -3   8  7   2   17  14  22  -8  -2  -10  12 -12  -19   25  -10  4  12 36 -5;

L1 = L[1,.]';
L2 = L[2,.]';
L = L1 + L2;
indx = sortind(L);
Ls = L[indx];
L1s = L1[indx];
L2s = L2[indx];

print "--------------------------------------------";
print strCombine(ftosa(L1[1:10]',"%lf",3,0)," ","");
print strCombine(ftosa(L2[1:10]',"%lf",3,0)," ","");
print strCombine(ftosa(L1[11:20]',"%lf",3,0)," ","");
print strCombine(ftosa(L2[11:20]',"%lf",3,0)," ","");
print "--------------------------------------------";
print strCombine(ftosa(L[1:10]',"%lf",3,0)," ","");
print strCombine(ftosa(L[11:20]',"%lf",3,0)," ","");
print "--------------------------------------------";
print strCombine(ftosa(Ls[1:10]',"%lf",3,0)," ","");
print strCombine(ftosa(Ls[11:20]',"%lf",3,0)," ","");
print "--------------------------------------------";
print strCombine(ftosa(L1s[1:10]',"%lf",3,0)," ","");
print strCombine(ftosa(L2s[1:10]',"%lf",3,0)," ","");
print strCombine(ftosa(L1s[11:20]',"%lf",3,0)," ","");
print strCombine(ftosa(L2s[11:20]',"%lf",3,0)," ","");

alpha = 0.80;
m = rows(L);

indx_alpha = m * alpha + 1;
VaR = Ls[indx_alpha];
RC1 = L1s[indx_alpha];
RC2 = L2s[indx_alpha];

print "--------------------------------------------";
print ftosa(VaR,"VaR = %lf",3,2);
print ftosa(RC1,"RC1 = %lf",3,2);
print ftosa(RC2,"RC2 = %lf",3,2);

ES = sumc(Ls .* (Ls .>= VaR))/(m - m*alpha);
RC1 = sumc(L1s .* (Ls .>= VaR))/(m - m*alpha);
RC2 = sumc(L2s .* (Ls .>= VaR))/(m - m*alpha);

print "--------------------------------------------";
print ftosa(ES,"ES = %lf",3,2);
print ftosa(RC1,"RC1 = %lf",3,2);
print ftosa(RC2,"RC2 = %lf",3,2);

p = weight_function(alpha,m,1);
VaR = sumc(p .* Ls);
RC1 = sumc(p .* L1s);
RC2 = sumc(p .* L2s);

print "--------------------------------------------";
print ftosa(VaR,"VaR = %lf",3,2);
print ftosa(RC1,"RC1 = %lf",3,2);
print ftosa(RC2,"RC2 = %lf",3,2);

proc weight_function(alpha,m,h);
  local indx_alpha,indx,p;

  indx_alpha = m * alpha + 1;
  indx = seqa(indx_alpha-h,1,2*h+1);

  p = zeros(m,1);
  p[indx] = ones(2*h+1,1)/(2*h+1);
  retp(p);
endp;


  