/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 129 (Table 2.22)
**
*/

new;
library rpb,pgraph;

cls;

rndseed 123;

let sigma = 0.25 0.22 0.14 0.30 0.40 0.30;

let rho = 1.00
          0.60 1.00
          0.60 0.60 1.00
          0.60 0.60 0.60 1.00
          0.60 0.60 0.60 0.60 1.00
          0.60 0.60 0.60 0.60 0.20 1.00;
rho = xpnd(rho);
call invpd(rho);

cov = sigma .* sigma' .* rho;
n = rows(cov);

__output = 0;

Results = miss(zeros(n+6,n*2),0);

i = 1;
do until i > 4;
  if i == 4;
      x = ones(n,1)/n;
  elseif i == 1;
    {x,vol,retcode} = Compute_MV_Portfolio(cov,ones(1,n),1,0,0,ones(n,1).*(0~1));
  elseif i == 2;
    {x,vol,mr,rc,prc} = Compute_ERC_Portfolio(0,cov);
  elseif i == 3;
    {x,vol,mr,rc,prc} = Compute_MDP_Portfolio(0,cov,0);
  endif;
  {vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
  D = Diversification_Index(x,cov);

  Results[1:n,2*(i-1)+1:2*i] = 100*(x~prc);
  Results[n+1:n+2,2*i] = 100*vol|D;

  p = x;
  {H,H1,N_eff} =Herfindahl_Index(p);
  {G1,G} = Gini_Index(p);
  {SE,I1} = Entropy_Index(p);

  p = prc;
  {H,H2,N_eff} = Herfindahl_Index(p);
  {G2,G} = Gini_Index(p);
  {SE,I2} = Entropy_Index(p);
  
  Results[n+3:n+5,2*(i-1)+1:2*i] = (H1~H2)|(G1~G2)|(I1~I2);

  i = i + 1;
endo;

cls;
print ftosa(results,"%lf",3,2);