/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 132 (Table 2.23)
**
*/

new;
library rpb,pgraph;

cls;

__ouput = 0;

let mu =    0.10 0.05 0.05;
let sigma = 0.30 0.20 0.15;
let rho = 1.00
          0.80 1.00
          0.50 0.30 1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';
n = rows(cov);

x0 = ones(n,1)/n;
let b = 0.50 0.20 0.30;

// Minimum risk portfolio

alpha = 0.90;

proc risk_criteria(x);
  local risk,mr,rc,prc;
  {risk,mr,rc,prc} = Compute_RC_ES(x,mu,cov,alpha);
  retp(risk);
endp;

_sqp_A = ones(1,n); _sqp_B = 1;
_sqp_Bounds = 0~1;
{x,fmin,grd,retcode} = sqpsolve(&risk_criteria,x0);
{risk,mr,rc,prc} = Compute_RC_ES(x,mu,cov,alpha);
result1 = (x~mr~rc~prc)|(error(0)~error(0)~risk~error(0));

x = b;
{risk,mr,rc,prc} = Compute_RC_ES(x,mu,cov,alpha);
result2 = (x~mr~rc~prc)|(error(0)~error(0)~risk~error(0));

{x,risk,mr,rc,prc} = Compute_RB_ES(x0,mu,cov,alpha,b);
result3 = (x~mr~rc~prc)|(error(0)~error(0)~risk~error(0));

cls;

print ftosa(100*result2,"%lf",3,2);
print "--------------------------------------------------------------------";

print ftosa(100*result3,"%lf",3,2);
print "--------------------------------------------------------------------";

print ftosa(100*result1,"%lf",3,2);
print "--------------------------------------------------------------------";

