/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 184 (Table 3.13)
**
*/

new;
library rpb,pgraph;

cls;

PathName = "data//";
datFileName = Pathname $+ "sx5e-info";
loads info = ^datFileName;
datFileName = Pathname $+ "sx5e-weights";
Composition = loadd(datFileName);
datFileName = Pathname $+ "sx5e-prices";
Prices = loadd(datFileName);
nStocks = cols(Prices) - 2;

Weights = Composition[.,2:cols(Composition)]/100;

EndDate = 20120928;

Rebalancing_Dates = Composition[.,1];
Rebalancing_Dates[1] = 19920101;
nRD = rows(Rebalancing_Dates);

Dates = Prices[.,1];
Index = Prices[.,2];
Prices = Prices[.,3:2+nStocks];

nAW = 8;
let lags = 21 42 65 260 520 780;

Turnover = zeros(rows(lags),nAW);

iter = 1;
do until iter > rows(lags);

  Lag_CovMatrix = lags[iter];
  FileName = itos("Results\\sx5e-Weights-",Lag_CovMatrix);
  loadm Computed_Weights = ^FileName;

  i = 1;
  do until i > nAW;
    Weights = array3d_get_x(Computed_Weights,i);
    Weights = selif(Weights,Rebalancing_Dates.<=EndDate);

    T = abs(Weights - lag1(Weights));
    if EndDate >= 20100129;
      T = delif(T,Rebalancing_Dates .== 20100129);
    endif;
    T = packr(T);
    Turnover[iter,i] = 12*meanc(sumr(T));
    i = i + 1;
  endo;

  iter = iter + 1;
endo;

Turnover = 100*Turnover;

print ftosa(Turnover[.,4 2 1 5 7 3 6 8],"%lf",3,0);
