/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 199 (Figure 4.3)
**
*/

new;
library rpb,pgraph;

cls;

let params = 0.05 -0.05 0.06 10;

param0 = params;
let param1 = 0.06 -0.05 0.06 10;
let param2 = 0.07 -0.07 0.06 10;
let param3 = 0.035 -0.035 0.09 5;

tau = seqa(0.001,0.10,301);
SpotRate1 = NelsonSiegel_Spot_Rate(param0~param1,tau);
SpotRate2 = NelsonSiegel_Spot_Rate(param0~param2,tau);
SpotRate3 = NelsonSiegel_Spot_Rate(param0~param3,tau);

graphset;
  window3u;

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|4|2;
  _paxht = 0.25;  _ptitlht = 0.275;  _pnumht = 0.20;
  xlabel("\216Maturity (in years)"); 
  xtics(0,20,5,12);
  ytics(0,6,1,2);

  setwind(1);
    title("\216Parallel shift");
    xy(tau,100*SpotRate1);

  setwind(2);
    title("\216Steepness of the slope");
    xy(tau,100*SpotRate2);

  setwind(3);
    title("\216Curvature movement");
    xy(tau,100*SpotRate3);

    graphprt("-c=1 -cf=chap4-2-2-1.eps");

  endwind;





