/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 246 (Figure 5.2)
**
*/

new;
library rpb,pgraph;

cls;

let x = 0 0.5 1 2 3 4 5;
let y1 = 100 95 90 84 82 81 80;
let y2 = 55 70 75 74 72 71 70;
y = y1~y2;

t = seqa(0,1/100,501);
b = fspline(csspline(x,y[.,1],1,1),t)~fspline(csspline(x,y[.,2],1,1),t);

t_c = 0.05|0.8;
b_c = fspline(csspline(x,y[.,1],1,1),t_c)~fspline(csspline(x,y[.,2],1,1),t_c);

x_a = (0.05|0.10|0.25|0.40|0.70|0.78|0.82) ~
      (0.10|0.10|0.20|0.50|0.70|0.75|0.80) ;
y_a = (56|56.5|57.5|59|65|70|73) ~
      (100|101|103.0|104|100|96|92) ;

t_a = seqa(0.05,0.75/100,104);
b_a = fspline(csspline(x_a[.,1],y_a[.,1],1,1),t_a)~fspline(csspline(x_a[.,1],y_a[.,2],1,1),t_a);

t_c = t_c~t_c;
t_c = vec(t_c);
b_c = vec(b_c);

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9,6.855,0,0,1);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pgrid = {3,1};
  _pcolor = 1|2;

  xtics(0,5,1,2);
  ytics(50,110,10,2);
  e = ones(4,1);
  _psym = t_c~b_c~e.*(8~5~12~1~10);
  let xlab = "T]1[" "T]2[" "T]3[" "T]4[" "T]5[" "T]6[" ;
  asclabel(xlab,0);

  setwind(1);
    xy(t,b);

  setwind(2);
    _pcolor = 5;  _pltype = 6;
    _parrow = 0.78~70~0.82~73~2.5~0.2~21~5~1~6~10 |
              0.78~96~0.82~93~2.5~0.2~21~5~1~6~10 ;
    _pmsgstr = "Backwardation\000Contango";
    _pmsgctl = 0.9~95~0.175~0~1~0~7 |
               0.8~65~0.175~0~1~0~7 ;
    xy(t_a,b_a);

    graphprt("-c=1 -cf=chap5-1-1-2.eps");

  endwind;

